#ifndef idB20734D678524FAA8AC94F2AB2FDAA94
#define idB20734D678524FAA8AC94F2AB2FDAA94

#include "scrapast.hpp"
#include <vector>

namespace duck {
	typedef std::vector<std::vector<std::pair<std::string, std::string>>> ResulList;
	struct element_def;

	namespace implem {
		class ResultPrinter {
		public:
			typedef void result_type;

			explicit ResultPrinter ( const std::vector<element_def>* parQueries, const ResultList* parResults );

			void operator() ( const element_def& parElem );
			void operator() ( const implem::map& parMap );
			void operator() ( const node_list& parNodes );

		private:
			const std::vector<element_def>* const m_queries;
			const ResulList* const m_results;
		};
	} //namespace implem
} //namespace duck

#endif
