/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef id0768F384342E4FD58028BE415A725169
#define id0768F384342E4FD58028BE415A725169

#include <string>

namespace std {
	template <typename Char, typename Traits>
	class basic_istream;

	typedef basic_istream<char> istream;
} //namespace std

namespace duck {
	std::string read_all ( std::istream& parStream );
	std::string read_all ( std::istream&& parStream );
	std::string read_all ( const std::string& parPath );
} //namespace duck

#endif
