/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef idC73DBB42FB76433BAFC0B73EAC3B70FF
#define idC73DBB42FB76433BAFC0B73EAC3B70FF

#include "scrap_node.hpp"
#include "scraplang/html_pool_base.hpp"
#include "xpath_fwd.hpp"
#include <string>

namespace duck { namespace sl {
	std::vector<std::string> apply (
		const ScrapNode& node,
		HtmlPoolBaseSP html_pool,
		XPathPtr xpath,
		std::string&& parDefNamespace
	);
}} //namespace duck::sl

#endif
